/* RAW socket utility routine:
 * 
 * Write out an IP header.
 * shadows@whitefang.com
 * Thamer Al-Herbish
 */

#include <stdlib.h>
#include <stdio.h>

#include <sys/types.h>
#include <sys/socket.h>

#include <netinet/in.h>
#include <arpa/inet.h>

#include <netinet/in_systm.h>
#include <netinet/ip.h>

#include <unistd.h>
#include <string.h>

#if !defined(HAVE_INCKSUM)
#include <checksum.h>
#endif

#if !defined(IPVERSION)
#define IPVERSION 4  /* Incase some system does not have this definition. */
#endif               /* We'll always be using 4 as the version anyway. */


#define DEFAULT_TTL 60  /* Just hard code the ttl in the ip header.*/

void ip_gen(char *packet,unsigned char protocol,struct in_addr saddr,
	    struct in_addr daddr,unsigned short length)
{
  struct iphdr *iphdr;

  iphdr = (struct iphdr *)packet;
  memset((char *)iphdr,'\0',sizeof(struct iphdr));
  
  iphdr->ihl = 5;
  iphdr->version = IPVERSION;
  iphdr->tot_len = htons(length);
  
  iphdr->id = htons(getpid());
  iphdr->ttl = DEFAULT_TTL;
  iphdr->protocol = protocol;

  iphdr->saddr = saddr.s_addr;
  iphdr->daddr = daddr.s_addr;

  iphdr->check = (unsigned short)in_cksum((unsigned short *)iphdr,
					  sizeof(struct iphdr));
  return;
}
